/** ***************************************************************************
 * @file  IniFile.h
 * @brief IniFileNX̎
 * @author Hidekazu Ito
 * @date 2015/02/26
 ******************************************************************************/

#define _CRT_SECURE_NO_WARNINGS

#include "IniFile.h"
#include <tchar.h>
#include <stdio.h>

using Win32Utility::IniFile;

/** *****************************************************************
 * @brief INIt@Cɕ
 * @param[in]  filePath  INIt@C(pX)
 * @param[in]  section   ZNV
 * @param[in]  key       L[
 * @param[in]  text      
 * @retval FALSE s
 * @retval TRUE  
 ********************************************************************/
BOOL IniFile::Save(LPCTSTR filePath, LPCTSTR section, LPCTSTR key, LPCTSTR text)
{
    return WritePrivateProfileString(
        section,
        key,
        text,
        filePath
    );
}

/** *****************************************************************
 * @brief INIt@Cɐl
 * @param[in]  filePath  INIt@C(pX)
 * @param[in]  section   ZNV
 * @param[in]  key       L[
 * @param[in]  value     l
 * @retval FALSE s
 * @retval TRUE  
 ********************************************************************/
BOOL IniFile::Save(LPCTSTR filePath, LPCTSTR section, LPCTSTR key, INT value)
{
    TCHAR buf[256];
    _stprintf(buf, TEXT("%d"), value );
    return WritePrivateProfileString(
        section,
        key,
        buf,
        filePath
    );
}

/** *****************************************************************
 * @brief INIt@C當ǂݍ
 * @param[in]   filePath    INIt@C(pX)
 * @param[in]   section     ZNV
 * @param[in]   key         L[
 * @param[out]  text        ̊i[
 * @param[in]   textLength  ̍ő咷()
 * @retval FALSE s
 * @retval TRUE  
 ********************************************************************/
BOOL IniFile::Load(LPCTSTR filePath, LPCTSTR section, LPCTSTR key, LPTSTR text, DWORD textLength)
{
    return GetPrivateProfileString(
        section,
        key,
        text,
        text,
        textLength,
        filePath
    );
}

/** *****************************************************************
 * @brief INIt@C琮lǂݍ
 * @param[in]   filePath  INIt@C(pX)
 * @param[in]   section   ZNV
 * @param[in]   key       L[
 * @param[out]  value     l̊i[
 * @retval FALSE s
 * @retval TRUE  
 ********************************************************************/
BOOL IniFile::Load(LPCTSTR filePath, LPCTSTR section, LPCTSTR key, INT *value)
{
    INT old = *value;
    *value = GetPrivateProfileInt(
        section,
        key,
        *value,
        filePath
    );
    if (*value == old) {
        return FALSE;
    }
    return TRUE;
}

// EOF